VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsProgressCopy"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'     ,    
' :    (The trick) 2013
Option Explicit

Private Declare Function HeapCreate Lib "kernel32" (ByVal flOptions As Long, ByVal dwInitialSize As Long, ByVal dwMaximumSize As Long) As Long
Private Declare Function HeapDestroy Lib "kernel32" (ByVal hHeap As Long) As Long
Private Declare Function HeapAlloc Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function HeapFree Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, lpMem As Any) As Long
Private Declare Function GetMem4 Lib "msvbvm60" (pSrc As Any, pDst As Any) As Long
Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Private Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Private Declare Function CreateThread Lib "kernel32" (lpThreadAttributes As Any, ByVal dwStackSize As Long, ByVal lpStartAddress As Long, lpParameter As Any, ByVal dwCreationFlags As Long, lpThreadID As Long) As Long
Private Declare Function GetExitCodeThread Lib "kernel32" (ByVal hThread As Long, lpExitCode As Long) As Long
Private Declare Function SetThreadPriority Lib "kernel32" (ByVal hThread As Long, ByVal nPriority As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Public Enum StateOperation
    COMPLETED                                                       '   
    ACTIVE                                                          '  
    FAILED                                                          '   
End Enum

Private Const STILL_ACTIVE = &H103&
Private Const PROGRESS_CONTINUE = 0
Private Const PROGRESS_CANCEL = 1
Private Const COPY_FILE_FAIL_IF_EXISTS = &H1
Private Const HEAP_CREATE_ENABLE_EXECUTE = &H40000
Private Const HEAP_NO_SERIALIZE = &H1
Private Const INFINITE = &HFFFFFFFF
Private Const THREAD_BASE_PRIORITY_MIN = -2
Private Const THREAD_PRIORITY_LOWEST = THREAD_BASE_PRIORITY_MIN

Private Const AsmSize As Long = 64                                  '    

Private mSourceFileName As String                                   ' ,  
Private mDestinationFileName As String                              ' ,  
Private mProgress As Single                                         '  0..1

Dim hHeap As Long                                                   '  
Dim lpFunc As Long                                                  '     
Dim init As Boolean                                                 '    
Dim Src() As Byte                                                   ' ASCII  mSourceFileName
Dim Dst() As Byte                                                   ' ASCII  mDestinationFileName
Dim ApiRet As Long                                                  '    API
Dim ProgressRet As Long                                             '    CopyProgressRoutine
Dim hThread As Long                                                 '  

Public Property Get SourceFileName() As String                      '    
    SourceFileName = mSourceFileName
End Property
Public Property Let SourceFileName(FileName As String)              '
    mSourceFileName = FileName
End Property
Public Property Get DestinationFileName() As String                 '    
    DestinationFileName = mDestinationFileName
End Property
Public Property Let DestinationFileName(FileName As String)         '
    mDestinationFileName = FileName
End Property
Public Property Get Progress() As Single                            '    0  1  
    Progress = mProgress
End Property
Public Property Get State() As StateOperation                       '    
    If Process Then State = ACTIVE: Exit Property
    State = IIf(ApiRet, COMPLETED, FAILED)
End Property
Public Sub Copy()                                                   '  
    Dim IDThrd As Long
    
    If Not init Or Process Then Exit Sub                            '         
    ProgressRet = PROGRESS_CONTINUE                                 '   
    LoadDynamicValue
    ApiRet = -1                                                     '    CopyFileEx
    hThread = CreateThread(ByVal 0, 0, lpFunc, ByVal 0, 0, IDThrd)  '   
    If hThread = 0 Then ApiRet = 0: Exit Sub                        '     ,   
    SetThreadPriority hThread, THREAD_PRIORITY_LOWEST               '     
End Sub
Public Function Cancel(Optional Wait As Boolean = False) As Boolean '   ,  ?
    If Process Then                                                 '      
        If Wait Then
            Call StopAll: Cancel = True                             '  
        Else
            ProgressRet = PROGRESS_CANCEL                           '     CPR
            Cancel = True
        End If
    End If
End Function
Private Property Get Process() As Boolean                           '  True   
    Dim Ret As Long
    If hThread = 0 Then Exit Property                               '    ,  False
    GetExitCodeThread hThread, Ret                                  ' ,   
    If Ret = STILL_ACTIVE Then Process = True                       '   ,   True
End Property
Private Sub StopAll()                                               '   
    ProgressRet = PROGRESS_CANCEL                                   '  
    If hThread Then
        WaitForSingleObject hThread, INFINITE                       '   
    End If
    hThread = 0
End Sub
Private Sub CreateAsm(Asm() As Long)                                '  
    ReDim Asm(-Int(-AsmSize / 4) - 1)                               '    
    Asm(0) = &H8950C031: Asm(1) = &H505150E1: Asm(2) = &H68&
    Asm(3) = &H6800&: Asm(4) = &H680000: Asm(5) = &HE8000000
    Asm(6) = &H0&: Asm(7) = &HA3&: Asm(8) = &HE8C03100
    Asm(9) = &H0&: Asm(10) = &HC246CDF: Asm(11) = &H4246CDF
    Asm(12) = &H1DD9F9DE: Asm(13) = &H0&: Asm(14) = &HA1&
    Asm(15) = &H34C200
End Sub
Private Sub LoadDynamicValue()                                      '     
    Src = StrConv(mSourceFileName & vbNullChar, vbFromUnicode)      '      ANSI
    Dst = StrConv(mDestinationFileName & vbNullChar, vbFromUnicode) ' ...
    
    GetMem4 VarPtr(Src(0)), ByVal lpFunc + &H13&                    '     
    GetMem4 VarPtr(Dst(0)), ByVal lpFunc + &HE&                     '    "" 
End Sub
Private Sub LoadStaticValue(lpFunc As Long)                         '     
    Dim hKernel32 As Long                                           '   Kernel32
    Dim lpCopyFileEx As Long                                        '   CopyFileEx
    Dim lpExitThread As Long                                        '   ExitThread

    hKernel32 = LoadLibrary("Kernel32.dll")                         '   Kernel32.dll
    lpCopyFileEx = GetProcAddress(hKernel32, "CopyFileExA")         '    ...
    lpExitThread = GetProcAddress(hKernel32, "ExitThread")          '
    
    GetMem4 lpFunc + &H28&, ByVal lpFunc + &H9&                     '    CopyProgressRoutine
    GetMem4 lpCopyFileEx - (lpFunc + &H1C&), ByVal lpFunc + &H18&   '    CopyFileExA
    GetMem4 lpExitThread - (lpFunc + &H28&), ByVal lpFunc + &H24&   '    ExitThread
    
    GetMem4 VarPtr(ApiRet), ByVal lpFunc + &H1D&                    '      CopyFileEx
    GetMem4 VarPtr(mProgress), ByVal lpFunc + &H34&                 '    mProgress
    GetMem4 VarPtr(ProgressRet), ByVal lpFunc + &H39&               '      CPR
End Sub
Private Sub Class_Initialize()
    Dim Asm() As Long                                               '    
    
    CreateAsm Asm                                                   '  
    hHeap = HeapCreate(HEAP_CREATE_ENABLE_EXECUTE Or _
            HEAP_NO_SERIALIZE, AsmSize, AsmSize)                    '  ,    ,
                                                                    '    
    If hHeap = 0 Then MsgBox "Error creating heap", vbCritical: _
            Exit Sub                                                '   
    lpFunc = HeapAlloc(hHeap, HEAP_NO_SERIALIZE, AsmSize)           '    
    If lpFunc = 0 Then MsgBox "HeapAlloc return NULL", _
            vbCritical: Call Class_Terminate: Exit Sub              '    
    CopyMemory ByVal lpFunc, Asm(0), AsmSize                        '     
    LoadStaticValue lpFunc
    ApiRet = -1                                                     '    State
    init = True                                                     '  
End Sub
Private Sub Class_Terminate()
    If Process Then
        StopAll                                                     ' 
    End If
    If lpFunc Then
        HeapFree hHeap, HEAP_NO_SERIALIZE, ByVal lpFunc             '   
    End If
    If hHeap Then
        HeapDestroy hHeap                                           '  
    End If
End Sub
